﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;
using System.Diagnostics;

namespace _117138
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            BindingList<Customer> cs = new BindingList<Customer>();

            cs.Add(new Customer()
            {
                FirstName = "A",
                LastName = "AA",
                Street = "AAAA",
                Contacts = new BindingList<Customer>(){new Customer(){FirstName = "A1",LastName = "B2", Contacts = null}, 
                                                        new Customer(){FirstName = "A2", Contacts = null}}

            });

            ultraGrid1.InitializeLayout += new Infragistics.Win.UltraWinGrid.InitializeLayoutEventHandler(ultraGrid1_InitializeLayout);

            ultraGrid1.DisplayLayout.MaxBandDepth = 2;

            ultraGrid1.DataSource = cs;

        }

        void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            e.Layout.MaxBandDepth = 2;

            // Setting SupportDataErrorInfo turns on the support for IDataErrorInfo.
            e.Layout.Override.SupportDataErrorInfo = SupportDataErrorInfo.RowsAndCells;

            // Set the appearance of cells, rows, and row selectors that have data errors.
            e.Layout.Override.DataErrorCellAppearance.BackColor = Color.Red;
            e.Layout.Override.DataErrorRowSelectorAppearance.BackColor = Color.Red;
            e.Layout.Override.DataErrorRowAppearance.BackColor = Color.Blue;
        }



    }

    public class Customer : IDataErrorInfo, INotifyPropertyChanged
    {
        public Customer() {
           
        }

        private string _firstName;
        public string FirstName
        {
            get { return _firstName; }
            set { _firstName = value;
            NotifyPropertyChanged("FirstName");
            }
        }

        private string _lastName;
        public string LastName
        {
            get { return _lastName; }
            set { _lastName = value;
            NotifyPropertyChanged("LastName");
            }
        }

        private string _street;
        public string Street
        {
            get { return _street; }
            set { _street = value;
            NotifyPropertyChanged("Street");
            }
        }

        private string _childError;
        [ReadOnly(true)]
        public string ChildError
        {
            get { return _childError; }
            set { _childError = value;
            NotifyPropertyChanged("ChildError");
            }
        }


        private BindingList<Customer> _contacts = new BindingList<Customer>();

        public BindingList<Customer> Contacts
        {
            get
            { return _contacts; }
               
            set { _contacts = value; }
        }

        #region IDataErrorInfo Members

        private string _lastError = "";

        [Browsable(false)]
        public string Error
        {
            get { return _lastError; }
        }

        public string this[string columnName]
        {
            get {

                Debug.WriteLine(columnName);
                switch( columnName )
                {
                    case "LastName":
                        if( String.IsNullOrEmpty( LastName ) )
                            _lastError = "Please insert a name!";
                        break;
                    case "ChildError":
                        if (_contacts != null && _contacts.Count > 0)
                        {
                            Customer c = _contacts.FirstOrDefault(cc => !string.IsNullOrEmpty(cc.Validate()));
                            _lastError = c != null ? c.Error : "";
                        }
                        break;

                    default: _lastError = "";
                        break;
                }

                return _lastError;
            }
        }

        private string Validate()
        {
            string err = "";
            //if (string.IsNullOrEmpty(this.FirstName))
              //  err = "Null First Name";
            if (string.IsNullOrEmpty(this.LastName))
                err = "Null Last Name";
            //if (string.IsNullOrEmpty(this.Street))
            //    err = "Null Street";
            _lastError = err;
            return err;

        }

        #endregion

        public event PropertyChangedEventHandler PropertyChanged;

        private void NotifyPropertyChanged(String info)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(info));
            }
        }
    }
}
